--[[
Author: Starinnia
Pitbull4_SoulShardBar - Adds a simple bar display of Soul Shards to Pitbull4
$Date: 2012-09-13 00:49:15 +0000 (Thu, 13 Sep 2012) $
$Revision: 9 $
Project Version: r9
contact: codemaster2010 AT gmail DOT com

Copyright (c) 2010-2012 Michael J. Murray aka Lyte of Lothar(US)
All rights reserved unless otherwise explicitly stated.
]]

if select(6, GetAddOnInfo("PitBull4_" .. (debugstack():match("[o%.][d%.][u%.]les\\(.-)\\") or ""))) ~= "MISSING" then return end

local PitBull4 = _G.PitBull4
if not PitBull4 then
	error("PitBull4_SoulShardBar requires PitBull4")
end

if select(2, UnitClass("player")) ~= "WARLOCK" then
	return
end

local EXAMPLE_VALUE = 2/3

local unpack = _G.unpack
local L = LibStub("AceLocale-3.0"):GetLocale("PitBull4_SoulShardBar")

local PitBull4_SoulShardBar = PitBull4:NewModule("SoulShardBar", "AceEvent-3.0")

PitBull4_SoulShardBar:SetModuleType("bar")
PitBull4_SoulShardBar:SetName(L["Soul Shard bar"])
PitBull4_SoulShardBar:SetDescription(L["Show a bar indicating the unit's Soul Shard count."])
PitBull4_SoulShardBar:SetDefaults({
	position = 3
})

function PitBull4_SoulShardBar:OnEnable()	
	self:RegisterEvent("UNIT_POWER")
	self:RegisterEvent("UNIT_DISPLAYPOWER")
	self:RegisterEvent("PLAYER_ENTERING_WORLD")
end

local function update_player(self)
	for frame in PitBull4:IterateFramesForUnitID("player") do
		if frame.SoulShardBar then
			self:Update(frame)
		end
	end
end

function PitBull4_SoulShardBar:UNIT_POWER(event, unit, kind)
	if unit ~= "player" or kind ~= "SOUL_SHARDS" then
		return
	end
	
	update_player(self)
end

function PitBull4_SoulShardBar:UNIT_DISPLAYPOWER(event, unit)
	if unit ~= "player" then
		return
	end
	
	update_player(self)
end

function PitBull4_SoulShardBar:PLAYER_ENTERING_WORLD(event)
	update_player(self)
end

local moduleUpdateFrame = PitBull4_SoulShardBar.UpdateFrame
function PitBull4_SoulShardBar:UpdateFrame(frame)
	if frame.unit ~= "player" then
		return self:ClearFrame(frame)
	end
	
	return moduleUpdateFrame(self, frame)
end

function PitBull4_SoulShardBar:GetValue(frame)
	return UnitPower("player", SPELL_POWER_SOUL_SHARDS) / UnitPowerMax("player", SPELL_POWER_SOUL_SHARDS)
end

function PitBull4_SoulShardBar:GetExampleValue(frame)
	return EXAMPLE_VALUE
end

function PitBull4_SoulShardBar:GetColor(frame, value)
	return unpack(PitBull4.PowerColors.SOUL_SHARDS)
end

function PitBull4_SoulShardBar:GetExampleColor(frame, value)
	return unpack(PitBull4.PowerColors.SOUL_SHARDS)
end
